/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   SatelliteLoop.h
 * Author: Maxi
 *
 * Created on 6. Dezember 2018, 14:28
 */

#ifndef SATELLITELOOP_H
#define SATELLITELOOP_H

#include "SATELLITE.h"
#include "GNSSParameters.h"
#include "enumSatelliteSystems.h"
#include <iostream>
#include <fstream>
#include <vector>
#include <iomanip>//std::setprecision

class SatelliteLoop {
public:
    SatelliteLoop();
    SatelliteLoop(const SatelliteLoop& orig);
    void writeInCsv(std::ofstream &streamData);
    void readOfFile(char*** pcInputData);
    virtual ~SatelliteLoop();
    void setiNumPotentialSat(int iAmount);
    void setArraybSatSys(bool *pbArray);
    void setiAmountSat(int iAmount);
    int getTotalVectorSize();
    void clearAllVectors();
    void resetPointers(); 
    
private:
    //Dynamic attributes+ Satellite attributes
    std::vector<SATELLITE> vecSatellite[4];//vector for 4 different Satellite Systems
    //std::array<std::deque<SATELLITE>, 4> dequeSatellite;
    SATELLITE *pSatellite=new SATELLITE;
    int iNumPotentialSat;
    bool arraybSatSys[4];
    
    int iAmountSat;
    int iAmountGPS;
    int iAmountEGNOS;
    int iAmountGLO;
    int iAmountGAL;
    int iAmountBEI;
    enumSatelliteSystems currentSatSys;
    
    //Methods private
    
    //void completeAmountListBeginning(enumSatelliteSystems &SatSys);
    //void completeAmountListEnding(enumSatelliteSystems &SatSys);
    void assignSatSys(enumSatelliteSystems &SatSys, int iconstexpres);
    void assignAmountGNSS(enumSatelliteSystems &SatSys);
    void fillVector(enumSatelliteSystems &SatSys);
    
};

#endif /* SATELLITELOOP_H */

